(* -*-sml-*- *)

(* -----------------------------------------------------------------------
 * This file contains some test cases for the interpreter
 * in "RG" mode. This is ML type inference with a graph based algorithm. 
 * Look at r_test.f for simple examples.
 *
 * The most interesting thing is that equi-recursive types are available
 * in this mode.
 *
 * author: Christian Mueller
 * -----------------------------------------------------------------------*)   

(* 1. polymorphic Fixpoint operator *)

rdef Fix = \f. (\x.\y. f (x x) y) (\x.\y. f (x x) y)

rdef sum = Fix (\f.\n.if n<=0 then 0 else n+f(n-1)) 

rdef result_1 = sum 4

(* 2. hungry function *)

def Hungry = mu A. Int -> A

rdef eat = Fix (\f:Int->Hungry.\n:Int.f)

rdef result_2 = eat 1 2 3 4 5 6 7 8 9 (* ... *)
